/* ------------------------------------------------------------------------ */
/*                                                                          */
/*  Copyright (C)                                                           */
/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful, but     */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-    */
/*  ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General        */
/*  Public License for more details.                                        */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   */
/*                                                                          */
/* ------------------------------------------------------------------------ */
/*  $Author: vogje02 $ $Revision: 1.3 $ $Date: 2002/07/09 10:55:30 $      */
/* ------------------------------------------------------------------------ */

#include "stdafx.h"
#include "nmapwin.h"
#include "scanpage.h"

extern COptions* options;

/////////////////////////////////////////////////////////////////////////////
// scanpage dialog

CScanPage::CScanPage(CWnd* pParent ) : CPropertyPage(CScanPage::IDD)
{
	//{{AFX_DATA_INIT(CScanPage)
	//}}AFX_DATA_INIT
	init = false;
}

void CScanPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScanPage)
	//}}AFX_DATA_MAP

	// Default settings
	if( !init ) {
		init = true;
		SetOptions();
	}
}


BEGIN_MESSAGE_MAP(CScanPage, CPropertyPage)
	//{{AFX_MSG_MAP(CScanPage)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio5)
	ON_BN_CLICKED(IDC_RADIO6, OnRadio6)
	ON_BN_CLICKED(IDC_RADIO7, OnRadio7)
	ON_BN_CLICKED(IDC_RADIO8, OnRadio8)
	ON_BN_CLICKED(IDC_RADIO9, OnRadio9)
	ON_BN_CLICKED(IDC_RADIO10, OnRadio10)
	ON_BN_CLICKED(IDC_RADIO11, OnRadio11)
	ON_BN_CLICKED(IDC_RADIO12, OnRadio12)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK7, OnCheck7)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_EN_CHANGE(IDC_EDIT2, OnChangeEdit2)
	ON_EN_CHANGE(IDC_EDIT4, OnChangeEdit4)
	ON_EN_CHANGE(IDC_EDIT3, OnChangeEdit3)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_EN_UPDATE(IDC_EDIT5, OnUpdateEdit5)
	ON_EN_CHANGE(IDC_EDIT5, OnChangeEdit5)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_EN_CHANGE(IDC_EDIT9, OnChangeEdit9)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/**
 * Update the widgets according to new options settings.
 */
void CScanPage::SetOptions()
{
	if( init ) {

		// Set the scan mode
		CheckRadioButton( IDC_RADIO1, IDC_RADIO12, IDC_RADIO1 + options->scanMode );
	
		// Port range 47512
		if( options->portRangeB ) {
			CheckDlgButton( IDC_CHECK4, BST_CHECKED );
			GetDlgItem( IDC_EDIT2 )->SetWindowText( options->portRangeS );
			GetDlgItem( IDC_EDIT2 )->EnableWindow( TRUE );
		}
		
		// Decoy
		if( options->decoyB ) {
			CheckDlgButton( IDC_CHECK7, BST_CHECKED );
			GetDlgItem( IDC_EDIT3 )->SetWindowText( options->decoyS );
			GetDlgItem( IDC_EDIT3 )->EnableWindow( TRUE );
		}

		// Device
		if( options->deviceB ) {
			CheckDlgButton( IDC_CHECK5, BST_CHECKED );
			GetDlgItem( IDC_EDIT4 )->SetWindowText( options->deviceS );
			GetDlgItem( IDC_EDIT4 )->EnableWindow( TRUE );
		}
		
		// Source address
		if( options->sAddressB ) {
			CheckDlgButton( IDC_CHECK3, BST_CHECKED );
			GetDlgItem( IDC_EDIT9 )->SetWindowText( options->sAddressS );
			GetDlgItem( IDC_EDIT9 )->EnableWindow( TRUE );
		}

		// Bounce
		if( options->bounceB ) {
			CheckDlgButton( IDC_CHECK1, BST_CHECKED );
			GetDlgItem( IDC_EDIT1 )->SetWindowText( options->bounceS );
			GetDlgItem( IDC_EDIT1 )->EnableWindow( TRUE );
		}

		// Source port
		if( options->portB ) {
			CheckDlgButton( IDC_CHECK2, BST_CHECKED );
			GetDlgItem( IDC_EDIT5 )->SetWindowText( options->portS );
			GetDlgItem( IDC_EDIT5 )->EnableWindow( TRUE );
		}
	}
}

void CScanPage::SetStatusBar( CEdit* status )
{
	m_statusbar = status;
}

void CScanPage::BuildCommand()
{
	char *val = (LPTSTR)malloc( 60 );

	// Scan options
	switch( GetCheckedRadioButton( IDC_RADIO1, IDC_RADIO12 ) )
	{
		case IDC_RADIO1: 
			options->scanMode = MODE_CONNECT;
			break;
		case IDC_RADIO2: 
			options->scanMode = MODE_SYN_STEALTH;
			break;
		case IDC_RADIO3: 
			options->scanMode = MODE_FIN_STEALTH;
			break;
		case IDC_RADIO4: 
			options->scanMode = MODE_PING_SWEEP;
			break;
		case IDC_RADIO5: 
			options->scanMode = MODE_UDP_SCAN;
			break;
		case IDC_RADIO6: 
			options->scanMode = MODE_NULL_SCAN;
			break;
		case IDC_RADIO7: 
			options->scanMode = MODE_XMAS_TREE;
			break;
		case IDC_RADIO8: 
			options->scanMode = MODE_IP_SCAN;
			break;
		case IDC_RADIO9: 
			options->scanMode = MODE_ACK_TREE;
			break;
		case IDC_RADIO10: 
			options->scanMode = MODE_WIN_SCAN;
			break;
		case IDC_RADIO11: 
			options->scanMode = MODE_RPC_SCAN;
			break;
		case IDC_RADIO12: 
			options->scanMode = MODE_LIST_SCAN;
			break;
	}

	// Port range selection
	if( IsDlgButtonChecked( IDC_CHECK4 ) ) {

		GetDlgItem( IDC_EDIT2 )->GetWindowText( val, 40 );

		if( val && *val )
			strcpy( options->portRangeS, val );
	}

	// Device output
	if( IsDlgButtonChecked( IDC_CHECK7 ) ) {

		GetDlgItem( IDC_EDIT4 )->GetWindowText( val, 40 );

		if( val && *val )
			strcpy( options->deviceS, val );
	}

	// Source address.
	if( IsDlgButtonChecked( IDC_CHECK3 ) ) {

		GetDlgItem( IDC_EDIT9 )->GetWindowText( val, 40 );

		if( val && *val )
			strcpy( options->sAddressS, val );
	}

	// Decoy setting
	if( IsDlgButtonChecked( IDC_CHECK5 ) ) {

		GetDlgItem( IDC_EDIT3 )->GetWindowText( val, 40 );

		if( val && *val )
			strcpy( options->decoyS, val );
	}

	// Bounce scan (FTP relay)
	if( IsDlgButtonChecked( IDC_CHECK1 ) ) {
	
		GetDlgItem( IDC_EDIT1 )->GetWindowText( val, 40 );

		if( val && *val )
			strcpy( options->bounceS, val );
	}

	// Source port
	if( IsDlgButtonChecked( IDC_CHECK2 ) ) {

		GetDlgItem( IDC_EDIT5 )->GetWindowText( val, 40 );

		if( val && *val )
			strcpy( options->portS, val );
	}

	char cmd[1024];
	options->GetCommand( cmd );
	m_statusbar->SetWindowText( cmd );
}

void CScanPage::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();	
}

void CScanPage::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();		
}

void CScanPage::OnRadio3() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();		
}

void CScanPage::OnRadio4() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();		
}

void CScanPage::OnRadio5() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();	
}

void CScanPage::OnRadio6() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();		
}

void CScanPage::OnRadio7() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();	
}

void CScanPage::OnRadio8() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();		
}

void CScanPage::OnRadio9() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();	
}

void CScanPage::OnRadio10() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();	
}

void CScanPage::OnRadio11() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();	
}

void CScanPage::OnRadio12() 
{
	// TODO: Add your control notification handler code here
	BuildCommand();	
}

// 'Bounce Scan' check box callback. This is just enabling/disabling the 'Bounce Scan'
// text field.
void CScanPage::OnCheck1() 
{
	options->bounceB = GetDlgItem( IDC_EDIT1 )->IsWindowEnabled() ? false : true;

	// Get the 'Bounce Scan' text field active
	if( GetDlgItem( IDC_EDIT1 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT1 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT1 )->EnableWindow( TRUE );

	BuildCommand();
}

// 'Source port' check box callback. This is just enabling/disabling the 'source port'
// text field.
void CScanPage::OnCheck2() 
{
	options->portB = IsDlgButtonChecked( IDC_CHECK2 ) ? true : false;

	// Get the 'Use Decoy' text field active
	if( GetDlgItem( IDC_EDIT5 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT5 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT5 )->EnableWindow( TRUE );

	BuildCommand();
}

// 'Port Range' check box callback. This is just enabling/disabling the 'Port Range'
// text field.
void CScanPage::OnCheck4() 
{
	options->portRangeB = GetDlgItem( IDC_EDIT2 )->IsWindowEnabled() ? false : true;

	// Get the 'Port Range' text field active	
	if( GetDlgItem( IDC_EDIT2 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT2 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT2 )->EnableWindow( TRUE );

	BuildCommand();
}

// 'Send on device' check box callback. This is just enabling/disabling the 'Send on device'
// text field.
void CScanPage::OnCheck7() 
{
	options->deviceB = GetDlgItem( IDC_EDIT4 )->IsWindowEnabled() ? false : true;

	// Get the 'Send on device' text field active	
	if( GetDlgItem( IDC_EDIT4 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT4 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT4 )->EnableWindow( TRUE );

	BuildCommand();	
}

// 'Source address' check box callback. This is just enabling/disabling the 'Address'
// text field.
void CScanPage::OnCheck3() 
{
	options->sAddressB = GetDlgItem( IDC_EDIT9 )->IsWindowEnabled() ? false : true;

	// Get the 'Send on device' text field active	
	if( GetDlgItem( IDC_EDIT9 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT9 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT9 )->EnableWindow( TRUE );

	BuildCommand();	
}

// 'Use decoy' check box callback. This is just enabling/disabling the 'Use Decoy'
// text field.
void CScanPage::OnCheck5() 
{
	options->decoyB = GetDlgItem( IDC_EDIT3 )->IsWindowEnabled() ? false : true;

	// Get the 'Use Decoy' text field active
	if( GetDlgItem( IDC_EDIT3 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT3 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT3 )->EnableWindow( TRUE );

	BuildCommand();
}

void CScanPage::OnChangeEdit2() 
{
	BuildCommand();
}

void CScanPage::OnChangeEdit4() 
{
	BuildCommand();
}

void CScanPage::OnChangeEdit3() 
{
	BuildCommand();
}

void CScanPage::OnChangeEdit1() 
{
	BuildCommand();
}

void CScanPage::OnUpdateEdit5() 
{
}

void CScanPage::OnChangeEdit5() 
{
	BuildCommand();
}

void CScanPage::OnChangeEdit9() 
{
	BuildCommand();
}

// Set the page visible. Position will be determined from parent
// widget, which is the options folder.
void CScanPage::SetVisible( CTabCtrl* parent )
{
	if( !IsWindow( m_hWnd ) ) {
		Create( IDD_DIALOG_SCAN, parent );
	
		CRect rectParent;
		parent->GetWindowRect( rectParent );

		SetWindowPos( parent, 5, 25, rectParent.Width() - 10, rectParent.Height()-27, 
					  SWP_NOZORDER | SWP_NOACTIVATE );
	}
	ShowWindow( SW_SHOW );
}
