/* ------------------------------------------------------------------------ */
/*                                                                          */
/*  Copyright (C)                                                           */
/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful, but     */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-    */
/*  ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General        */
/*  Public License for more details.                                        */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   */
/*                                                                          */
/* ------------------------------------------------------------------------ */
/*  $Author: vogje02 $ $Revision: 1.5 $ $Date: 2002/07/28 17:13:20 $      */
/* ------------------------------------------------------------------------ */

//{{AFX_INCLUDES()
#include "calendar.h"
//}}AFX_INCLUDES

#if !defined(AFX_SERVICEPAGE_H__D1EDD9C5_C182_49EA_87EB_4265687549A1__INCLUDED_)
#define AFX_SERVICEPAGE_H__D1EDD9C5_C182_49EA_87EB_4265687549A1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Service scan factors
#define INTERVAL_MINUTES  0
#define INTERVAL_HOURS    1
#define INTERVAL_DAYS     2
#define INTERVAL_WEEKS    3
#define INTERVAL_MONTHS   4

#define atob(s) ( strncmp( s, "1", 1 ) == 0 ? true : false )

#include "scanpage.h"
#include "discoverpage.h"
#include "optionspage.h"
#include "timingpage.h"
#include "filespage.h"
#include "windowspage.h"
#include "options.h"

/**
 * Service page fo the options folder
 */
class CServicePage : public CPropertyPage
{
public:
	/**
	 * Construction
	 */
	CServicePage();
	
	/**
	 * Destruction
	 */
	~CServicePage();

	/**
	 * Called when the page becomes visable. This is putting
	 * the page into t he right place.
	 */
	void  SetVisible(CTabCtrl* parent);

	/**
	 * Set status bar for error/info messages
	 */
	void  SetStatusBar( CEdit* status, CEdit* vstatus, CEdit* hostedit );

	/**
	 * Set the page values. This is needed in order to update
	 * the pages with the new values, after an update from the
	 * registry.
	 */
	void SetPages( CScanPage* scanPage, CDiscoverPage* discoverPage,
				   COptionsPage* optionsPage, CTimingPage* timingPage,
				   CFilesPage* filesPage, CWindowsPage* windowsPage );

	// Dialog Data
	//{{AFX_DATA(CServicePage)
	enum { IDD = IDD_DIALOG_SERVICE };
	CButton	m_immediately;
	CButton	m_autostart;
	CButton	m_sat;
	CButton	m_fri;
	CButton	m_thu;
	CButton	m_wed;
	CButton	m_tue;
	CButton	m_mon;
	CButton	m_sun;
	CDateTimeCtrl	m_starttime;
	CDateTimeCtrl	m_startdate;
	CEdit	m_slidertext2;
	CEdit	m_slidervalue;
	CEdit	m_slidertext1;
	CButton	m_slidertext;
	CComboBox	m_intervalfactor;
	CSliderCtrl	m_interval;
	CCalendar	m_calendar;
	//}}AFX_DATA


	// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CServicePage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CServicePage)
	afx_msg void OnButton1();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	afx_msg void OnButton5();
	afx_msg void OnButton6();
	afx_msg void OnCloseupDatetimepicker1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnOutofmemorySlider1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEditchangeCombo1();
	afx_msg void OnSelendokCombo1();
	afx_msg void OnReleasedcaptureSlider1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeEdit3();
	afx_msg void OnCustomdrawSlider1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnAutoStart();
	afx_msg void OnImmediately();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	/**
	 * Initialization flag
	 */
	bool init;

	/**
	 * Service arguments
	 */
	char servArgs[1024];

	/**
	 * NMap arguments
	 */
	char nmapArgs[1024];

	/**
	 * Get the registry arguments
	 */
	bool GetRegistryArgs();

	/** 
	 * Set the registry arguments
	 */
	void SetRegistryArgs();

	/**
	 * Parse the service arguments.
	 */
	void ParseServiceArgs();

	/**
	 * Parse the nmap arguments.
	 */
	void ParseNMapArgs();

	/**
	 * Status bar for error messages
	 */
	CEdit* m_statusbar;

	/**
	 * Invisible status message box.
	 */
	CEdit* m_vstatus;

	/**
	 * Host edit box
	 */
	CEdit* m_hostedit;

	/**
	 * Scan pages
	 */
	CScanPage* m_scanPage;

	/**
	 * Discover pages
	 */
	CDiscoverPage* m_discoverPage;

	/**
	 * Options pages
	 */
	COptionsPage* m_optionsPage;

	/**
	 * Timing pages
	 */
	CTimingPage* m_timingPage;

	/**
	 * Files pages
	 */
	CFilesPage* m_filesPage;

	/**
	 * Windows pages
	 */
	CWindowsPage* m_windowsPage;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SERVICEPAGE_H__D1EDD9C5_C182_49EA_87EB_4265687549A1__INCLUDED_)
