/* ------------------------------------------------------------------------ */
/*                                                                          */
/*  Copyright (C)                                                           */
/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful, but     */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-    */
/*  ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General        */
/*  Public License for more details.                                        */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   */
/*                                                                          */
/* ------------------------------------------------------------------------ */
/*  $Author: vogje02 $ $Revision: 1.3 $ $Date: 2002/07/09 10:55:30 $      */
/* ------------------------------------------------------------------------ */

#include "stdafx.h"
#include "nmapwin.h"
#include "timingpage.h"

extern COptions* options;

/////////////////////////////////////////////////////////////////////////////
// CTimingPage property page

CTimingPage::CTimingPage() : CPropertyPage(CTimingPage::IDD)
{
	//{{AFX_DATA_INIT(CTimingPage)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	init = false;
}

CTimingPage::~CTimingPage()
{
}

void CTimingPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimingPage)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP

	// Default settings
	if( !init ) {
		init = true;
		SetOptions();
	}
}


BEGIN_MESSAGE_MAP(CTimingPage, CPropertyPage)
	//{{AFX_MSG_MAP(CTimingPage)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK8, OnCheck8)
	ON_BN_CLICKED(IDC_CHECK10, OnCheck10)
	ON_BN_CLICKED(IDC_CHECK11, OnCheck11)
	ON_BN_CLICKED(IDC_CHECK13, OnCheck13)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_EN_CHANGE(IDC_EDIT12, OnChangeEdit12)
	ON_EN_CHANGE(IDC_EDIT13, OnChangeEdit13)
	ON_EN_CHANGE(IDC_EDIT14, OnChangeEdit14)
	ON_EN_CHANGE(IDC_EDIT15, OnChangeEdit15)
	ON_EN_CHANGE(IDC_EDIT16, OnChangeEdit16)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio5)
	ON_BN_CLICKED(IDC_RADIO6, OnRadio6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimingPage message handlers

void CTimingPage::SetOptions()
{
	if( init ) {

		if( options->hostTimeoutB ) {
			CheckDlgButton( IDC_CHECK1, BST_CHECKED );
			GetDlgItem( IDC_EDIT1 )->EnableWindow( TRUE );
			GetDlgItem( IDC_EDIT1 )->SetWindowText( options->hostTimeout );
		} 
		
		if( options->minRttB ) {
			CheckDlgButton( IDC_CHECK3, BST_CHECKED );
			GetDlgItem( IDC_EDIT12 )->EnableWindow( TRUE );
			GetDlgItem( IDC_EDIT12 )->SetWindowText( options->minRtt );
		}

		if( options->maxRttB ) {
			CheckDlgButton( IDC_CHECK8, BST_CHECKED );
			GetDlgItem( IDC_EDIT13 )->EnableWindow( TRUE );
			GetDlgItem( IDC_EDIT13 )->SetWindowText( options->maxRtt );
		}

		if( options->initialRttB ) {
			CheckDlgButton( IDC_CHECK10, BST_CHECKED );
			GetDlgItem( IDC_EDIT14 )->EnableWindow( TRUE );
			GetDlgItem( IDC_EDIT14 )->SetWindowText( options->initialRtt );
		}
		
		if( options->parallelB ) {
			CheckDlgButton( IDC_CHECK11, BST_CHECKED );
			GetDlgItem( IDC_EDIT15 )->EnableWindow( TRUE );
			GetDlgItem( IDC_EDIT15 )->SetWindowText( options->parallel );
		}

		if( options->delayB ) {
			CheckDlgButton( IDC_CHECK13, BST_CHECKED );
			GetDlgItem( IDC_EDIT16 )->EnableWindow( TRUE );
			GetDlgItem( IDC_EDIT16 )->SetWindowText( options->delay );
		}

		CheckRadioButton( IDC_RADIO1, IDC_RADIO6, IDC_RADIO1 + atoi( options->throttle ) );
	}
}

/**
 * Set the status bar
 */
void CTimingPage::SetStatusBar( CEdit* status )
{
	m_statusbar = status;
}

/**
 * Buidl the options command from the widgets
 */
void CTimingPage::BuildCommand()
{
	char *val = (LPTSTR)malloc( 60 );

	// Throttle
	switch( GetCheckedRadioButton( IDC_RADIO1, IDC_RADIO6 ) )
	{
		case IDC_RADIO1: 
			sprintf( options->throttle, "0" );
			break;
		case IDC_RADIO2: 
			sprintf( options->throttle, "1" );
			break;
		case IDC_RADIO3: 
			sprintf( options->throttle, "2" );
			break;
		case IDC_RADIO4: 
			sprintf( options->throttle, "3" );
			break;
		case IDC_RADIO5: 
			sprintf( options->throttle, "4" );
			break;
		case IDC_RADIO6: 
			sprintf( options->throttle, "5" );
			break;
	}

	// Host timeout
	if( IsDlgButtonChecked( IDC_CHECK1 ) ) {

		GetDlgItem( IDC_EDIT1 )->GetWindowText( val, 40 );

		if( val && *val && atoi( val ) > 0 ) 
			strcpy( options->hostTimeout, val );
	}

	// Minimum rtt timeout
	if( IsDlgButtonChecked( IDC_CHECK3 ) ) {

		GetDlgItem( IDC_EDIT12 )->GetWindowText( val, 40 );

		if( val && *val && atoi( val ) > 0 )
			strcpy( options->minRtt, val );
	}

	// Maximum rtt timeout
	if( IsDlgButtonChecked( IDC_CHECK8 ) ) {

		GetDlgItem( IDC_EDIT13 )->GetWindowText( val, 40 );

		if( val && *val && atoi( val ) > 0 )
			strcpy( options->maxRtt, val );
	}

	// Initial rtt timeout
	if( IsDlgButtonChecked( IDC_CHECK10 ) ) {

		GetDlgItem( IDC_EDIT14 )->GetWindowText( val, 40 );

		if( val && *val && atoi( val ) > 0 )
			strcpy( options->initialRtt, val );
	}

	// Max parallelism
	if( IsDlgButtonChecked( IDC_CHECK11 ) ) {

		GetDlgItem( IDC_EDIT15 )->GetWindowText( val, 40 );

		if( val && *val && atoi( val ) > 0 )
			strcpy( options->parallel, val );
	}

	// Scan delay
	if( IsDlgButtonChecked( IDC_CHECK13 ) ) {

		GetDlgItem( IDC_EDIT16 )->GetWindowText( val, 40 );

		if( val && *val && atoi( val ) > 0 )
			strcpy( options->delay, val );
	}

	char cmd[1024];
	options->GetCommand( cmd );
	m_statusbar->SetWindowText( cmd );
}

void CTimingPage::OnCheck1() 
{
	options->hostTimeoutB = IsDlgButtonChecked( IDC_CHECK1 ) ? true : false;	

	// Get the 'Bounce Scan' text field active
	if( GetDlgItem( IDC_EDIT1 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT1 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT1 )->EnableWindow( TRUE );

	BuildCommand();
}

void CTimingPage::OnCheck3() 
{
	options->minRttB = IsDlgButtonChecked( IDC_CHECK3 ) ? true : false;	

	// Get the 'Minimum RTT' text field active
	if( GetDlgItem( IDC_EDIT12 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT12 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT12 )->EnableWindow( TRUE );

	BuildCommand();	
}

void CTimingPage::OnCheck8() 
{
	options->maxRttB = IsDlgButtonChecked( IDC_CHECK8 ) ? true : false;	

	// Get the 'Maximum RTT' text field active
	if( GetDlgItem( IDC_EDIT13 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT13 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT13 )->EnableWindow( TRUE );

	BuildCommand();
}

void CTimingPage::OnCheck10() 
{
	options->initialRttB = IsDlgButtonChecked( IDC_CHECK10 ) ? true : false;	

	// Get the 'Initial' text field active
	if( GetDlgItem( IDC_EDIT14 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT14 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT14 )->EnableWindow( TRUE );

	BuildCommand();
}

void CTimingPage::OnCheck11() 
{
	options->parallelB = IsDlgButtonChecked( IDC_CHECK11 ) ? true : false;	

	// Get the 'Parallel' text field active
	if( GetDlgItem( IDC_EDIT15 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT15 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT15 )->EnableWindow( TRUE );

	BuildCommand();
}

void CTimingPage::OnCheck13() 
{
	options->delayB = IsDlgButtonChecked( IDC_CHECK13 ) ? true : false;	

	// Get the 'Scan delay' text field active
	if( GetDlgItem( IDC_EDIT16 )->IsWindowEnabled() )
		GetDlgItem( IDC_EDIT16 )->EnableWindow( FALSE );
	else
		GetDlgItem( IDC_EDIT16 )->EnableWindow( TRUE );

	BuildCommand();
}

void CTimingPage::OnChangeEdit1() 
{
	BuildCommand();
}

void CTimingPage::OnChangeEdit12() 
{
	BuildCommand();	
}

void CTimingPage::OnChangeEdit13() 
{
	BuildCommand();	
}

void CTimingPage::OnChangeEdit14() 
{
	BuildCommand();
}

void CTimingPage::OnChangeEdit15() 
{
	BuildCommand();
}

void CTimingPage::OnChangeEdit16() 
{
	BuildCommand();	
}

void CTimingPage::SetVisible( CTabCtrl* parent )
{
	if( !IsWindow( m_hWnd ) ) {
		Create( IDD_DIALOG_TIMING, parent );
	
		CRect rectParent;
		parent->GetWindowRect( rectParent );

		SetWindowPos( parent, 5, 25, rectParent.Width() - 10, rectParent.Height()-27, 
					  SWP_NOZORDER | SWP_NOACTIVATE );
	}
	ShowWindow( SW_SHOW );
}

void CTimingPage::OnRadio1() 
{
	BuildCommand();	
}

void CTimingPage::OnRadio2() 
{
	BuildCommand();	
}

void CTimingPage::OnRadio3() 
{
	BuildCommand();	
}

void CTimingPage::OnRadio4() 
{
	BuildCommand();	
}

void CTimingPage::OnRadio5() 
{
	BuildCommand();	
}

void CTimingPage::OnRadio6() 
{
	BuildCommand();	
}
