/* ------------------------------------------------------------------------ */
/*                                                                          */
/*  Copyright (C)                                                           */
/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful, but     */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-    */
/*  ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General        */
/*  Public License for more details.                                        */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   */
/*                                                                          */
/* ------------------------------------------------------------------------ */
/*  $Author: vogje02 $ $Revision: 1.3 $ $Date: 2002/07/09 10:55:30 $        */
/* ------------------------------------------------------------------------ */

#include "stdafx.h"
#include "nmapwin.h"
#include "windowspage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern COptions* options;

/////////////////////////////////////////////////////////////////////////////
// CWindowsPage property page

IMPLEMENT_DYNCREATE(CWindowsPage, CPropertyPage)

/**
 * Constructor
 */
CWindowsPage::CWindowsPage() : CPropertyPage(CWindowsPage::IDD)
{
	//{{AFX_DATA_INIT(CWindowsPage)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

/**
 * Destructor
 */
CWindowsPage::~CWindowsPage()
{
}

/**
 * Exchange the data for the widgets
 */
void CWindowsPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWindowsPage)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWindowsPage, CPropertyPage)
	//{{AFX_MSG_MAP(CWindowsPage)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWindowsPage message handlers

/**
 * Set the status bar
 */
void CWindowsPage::SetStatusBar( CEdit* status )
{
	m_statusbar = status;
}

/**
 * Make the window visible
 */
void CWindowsPage::SetVisible( CTabCtrl* parent )
{
	if( !IsWindow( m_hWnd ) ) {
		Create( IDD_DIALOG_WINDOWS, parent );
	
		CRect rectParent;
		parent->GetWindowRect( rectParent );

		SetWindowPos( parent, 5, 25, rectParent.Width() - 10, rectParent.Height()-27, 
					  SWP_NOZORDER | SWP_NOACTIVATE );
	}
	ShowWindow( SW_SHOW );
}

/**
 * Make a local copy of the options struct
 */
void CWindowsPage::SetOptions()
{
	if( init ) {
		if( options->winNoPcapB )
			CheckDlgButton( IDC_CHECK1, BST_CHECKED );
		if( options->winNoHlpApiB )
			CheckDlgButton( IDC_CHECK4, BST_CHECKED );
		if( options->winNoRawSocketB )
			CheckDlgButton( IDC_CHECK2, BST_CHECKED );
		if( options->winNoRawSocketB )
			CheckDlgButton( IDC_CHECK2, BST_CHECKED );
		if( options->winForceRawSocketB )
			CheckDlgButton( IDC_CHECK3, BST_CHECKED );
		if( options->winNt4RouteB )
			CheckDlgButton( IDC_CHECK5, BST_CHECKED );
		if( options->winTraceB )
			CheckDlgButton( IDC_CHECK6, BST_CHECKED );

	}
}

/**
 * Buidl the options command from the widgets
 */
void CWindowsPage::BuildCommand()
{
	// No Pcap
	options->winNoPcapB = IsDlgButtonChecked( IDC_CHECK1 ) ? true : false;

	// No HLP api
	options->winNoHlpApiB = IsDlgButtonChecked( IDC_CHECK4 ) ? true : false;

	// No raw sockets
	options->winNoRawSocketB = IsDlgButtonChecked( IDC_CHECK2 ) ? true : false;

	// Force raw sockets
	options->winForceRawSocketB = IsDlgButtonChecked( IDC_CHECK3 ) ? true : false;

	// NT4 routing
	options->winNt4RouteB = IsDlgButtonChecked( IDC_CHECK5 ) ? true : false;

	// Windows trace
	options->winTraceB = IsDlgButtonChecked( IDC_CHECK6 ) ? true : false;

	char cmd[1024];
	options->GetCommand( cmd );
	m_statusbar->SetWindowText( cmd );
}

void CWindowsPage::OnButton1() 
{
	options->winInterfaceB = true;

	char cmd[1024];
	options->GetCommand( cmd );
	m_statusbar->SetWindowText( cmd );
}

void CWindowsPage::OnCheck1() 
{
	BuildCommand();
}

void CWindowsPage::OnCheck4() 
{
	BuildCommand();
}

void CWindowsPage::OnCheck2() 
{
	BuildCommand();
}

void CWindowsPage::OnCheck3() 
{
	BuildCommand();
}

void CWindowsPage::OnCheck5() 
{
	BuildCommand();
}

void CWindowsPage::OnCheck6() 
{
	BuildCommand();
}
